# -*- coding: utf-8 -*-

import os
import time

import allure
import pytest
from BasePage.BasePage import BasePage
from Pages.PageManagementPage.VideoSurveillancePage import VideoSurveillancePage


@allure.epic("CMS2.0UI自动化测试")
@allure.feature("视频监控组件")
class Test_VideoSurveillance:
	@allure.story("视频监控-创建视频监控组件")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance","视频监控_创建视频监控_实际图", "视频监控_创建视频监控_预期图")])
	def test_create_VideoSurveillance(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.create_video_surveillance()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-位置-修改x、y、w、h属性")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_修改xywh属性_实际图", "视频监控_修改xywh属性_预期图")])
	def test_VideoSurveillance_set_xywh_axis(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_xywh()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-位置-修改旋转角度")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_修改旋转角度_实际图", "视频监控_修改旋转角度_预期图")])
	def test_VideoSurveillance_set_rotation_angle(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_rotation_angle()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-位置-设置锁定")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置锁定_实际图", "视频监控_设置锁定_预期图")])
	def test_VideoSurveillance_set_lock(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_lock()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置纯色背景")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置纯色背景_实际图", "视频监控_设置纯色背景_预期图")])
	def test_VideoSurveillance_set_solid_color_background(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_solid_color_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置渐变色背景")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置渐变色背景_实际图", "视频监控_设置渐变色背景_预期图")])
	def test_VideoSurveillance_set_gradient_color_background(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_gradient_color_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置图片背景，且为拉伸类型")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name", [("VideoSurveillance", "视频监控_设置图片背景_拉伸类型_实际图", "视频监控_设置图片背景_拉伸类型_预期图")])
	def test_VideoSurveillance_set_stretch_type_image_background(self, page, create_and_destroy_page, filename,actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_stretch_type_image_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置图片背景，且为自适应类型")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置图片背景_自适应类型_实际图","视频监控_设置图片背景_自适应类型_预期图")])
	def test_VideoSurveillance_set_adapt_type_image_background(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_adapt_type_image_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置图片背景，且为覆盖类型")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name", [("VideoSurveillance", "视频监控_设置图片背景_覆盖类型_实际图", "视频监控_设置图片背景_覆盖类型_预期图")])
	def test_VideoSurveillance_set_cover_type_image_background(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_cover_type_image_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置图片背景，且为实际大小类型")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name", [("VideoSurveillance", "视频监控_设置图片背景_实际大小类型_实际图", "视频监控_设置图片背景_实际大小类型_预期图")])
	def test_VideoSurveillance_set_actual_type_image_background(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_actual_type_image_background()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置直线边框")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置直线边框_实际图", "视频监控_设置直线边框_预期图")])
	def test_VideoSurveillance_set_straight_line_frame(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_straight_line_frame()  # 直线
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置虚线边框")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置虚线边框_实际图", "视频监控_设置虚线边框_预期图")])
	def test_VideoSurveillance_set_dashed_line_frame(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_dashed_line_frame()  # 虚线
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置圆点边框")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置圆点边框_实际图", "视频监控_设置圆点边框_预期图")])
	def test_VideoSurveillance_set_scircular_dots_frame(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_scircular_dots_frame()  # 圆点
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置无边框")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置无边框_实际图", "视频监控_设置无边框_预期图")])
	def test_VideoSurveillance_set_no_frame(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_no_frame()  # 无边框
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置内外阴影")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置内外阴影_实际图", "视频监控_设置内外阴影_预期图")])
	def test_VideoSurveillance_set_shadow(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_shadow()  # 设置内外阴影
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置圆角")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置圆角_实际图", "视频监控_设置圆角_预期图")])
	def test_VideoSurveillance_set_rounded_corners(self, page, create_and_destroy_page, filename, actual_img_name,expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_rounded_corners()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"

	@allure.story("视频监控-外观-设置不透明度")
	@pytest.mark.parametrize("filename,actual_img_name,expect_img_name",[("VideoSurveillance", "视频监控_设置不透明度_实际图", "视频监控_设置不透明度_预期图")])
	def test_VideoSurveillance_set_opacity(self, page, create_and_destroy_page, filename, actual_img_name, expect_img_name):
		bp = BasePage(page)
		bp._goto_url("画面")
		vsp = VideoSurveillancePage(page)
		vsp.set_opacity()
		time.sleep(1)
		result = bp.compare_images(filename, actual_img_name, expect_img_name)
		bp.allure_reports(filename, actual_img_name, expect_img_name)
		assert result, f"页面截图与预期截图不一致"